/////////////////////////////////////////////////////
// OutOfBounds Exception Handling class for ARRAY ADT
//   -Class implementation
// Author: Jonathan Lavering
//
/////////////////////////////////////////////////////

#include "OutOfBounds.h"
#include <cstring>

// constructor
OutOfBounds::OutOfBounds( char * newErrorMsg )
{
	ErrorMsg = new char[ strlen( newErrorMsg ) + 1 ];
	strcpy( ErrorMsg, newErrorMsg );
}

// default constructor
OutOfBounds::OutOfBounds()
{
	char * temp = "Out of bounds exception.";

	ErrorMsg = new char[ strlen( temp ) + 1 ];
	strcpy( ErrorMsg, temp );
}

// destructor
OutOfBounds::~OutOfBounds()
{
	delete [] ErrorMsg;
}

// copy constructor
OutOfBounds::OutOfBounds( const OutOfBounds & copy )
{
	*this = copy;
}

// operator equals
OutOfBounds & OutOfBounds::operator = ( const OutOfBounds & copy )
{
	if( this != &copy )
	{
		delete [] ErrorMsg; // delete it if it exists

		ErrorMsg = new char[ strlen( copy.GetMsg() ) + 1 ];
		strcpy( ErrorMsg, copy.GetMsg() );
	}

	return *this;
}

// return error msg
char * OutOfBounds::GetMsg() const
{
	return ErrorMsg;
}