#ifndef ROW_H
#define ROW_H

template <typename T>
class Array2D;

template <typename T>
class Row
{ 
public:
    Row( Array2D< T > & array, int row );     
    T & operator [] ( int column ) const;

	int GetRow() const;
private:
	Array2D< T >& m_array2D;
	int m_row;
};

template <typename T>
Row< T >::Row( Array2D< T > & array, int row )
:m_array2D( array )
{
	m_row = row;
}

template <typename T>
T & Row< T >::operator [] ( int column ) const
{
	if( column < 0 || column >= m_array2D.GetColumns() )
		throw OutOfBounds( "ERROR: Column index out of bounds." );

	return m_array2D.Select( m_row , column );
}

template <typename T>
int Row< T >::GetRow() const
{
	return m_row;
}

#endif